/*
	butterfly1() - draws a modified tschirnhausen figure
*/

#include <graphics.h>
#include <conio.h>

extern	step,
	quadrant(int,int,int,int),
	keyhit(void);


int butterfly1(int x1,int y1,int x2,int y2)
/* modified tschirnhausen's algorithm */
{
  int		c=getcolor(),
		xcenter=(x1+x2)>>1,
		ycenter=(y1+y2)>>1,
		quad=quadrant(x1,y1,x2,y2);
  double	x,y,
		a,b,
		bstart=-3.4,		/* -3.4		*/
		bend=2.9,		/*  2.9		*/
		bstep=0.1,		/*  0.1		*/
		astart=0.02,		/*  0.02	*/
		aend=2.0,		/*  step/4.0	*/
		astep=step/40.0;	/*  0.1		*/

  for(a=astart;a<=aend;a+=astep)
    for(b=bstart;b<=bend;b+=bstep)
    {
      if(kbhit()) keyhit();
      x=3*a*(b-3);
      y=b*a*(b*b-3);
      switch(quad)
      {
	case 1:  putpixel(xcenter+x,ycenter+y,c);	break;
	case 2:  putpixel(xcenter-x,ycenter+y,c);	break;
	case 3:  putpixel(xcenter-x,ycenter-y,c);	break;
	case 4:  putpixel(xcenter+x,ycenter-y,c);	break;
	default: return;
      }
    }
}
