/*
	circles1() - draws nested circles, radius is decreasing integer
	circles2() - draws nested circles, radius is decreasing float
	circles3() - same as circles2() w/line to center of screen
*/

#include <graphics.h>
#include <conio.h>
#include <stdlib.h>

extern	step,
	xc,yc,
	mwright, mwbottom,
	symmetry,
	keyhit(void);


int circles1(int x1,int y1,int x2,int y2)
{
  int	r=1+step%5,
	x=(x1+x2)>>1,
	y=(y1+y2)>>1;

  while(r>=0)
  {
    circle(x,y,r);
    r-=2;
    if(kbhit()) keyhit();
  }
}


int circles2(int x1,int y1,int x2,int y2,float randomfloat)
{
  float	r=6+step%4,
	rstep=1+randomfloat;
  int	x=(x1+x2)>>1,
	y=(y1+y2)>>1;

  while(r>=0)
  {
    circle(x,y,(int)r);
    r-=rstep;
    if(kbhit())
      keyhit();
  }
}


int circles3(int x1,int y1,int x2,int y2,float randomfloat)
{
  float	r=3+step%3,
	rstep=0.2+randomfloat;
  int	x=(x1+x2)>>1,
	y=(y1+y2)>>1;

  switch(symmetry)	/* fall-through is deliberate */
  {
    case 8:
    case 4:  line(x,y,x,mwbottom-y);
	     line(mwright-x,y,mwright-x,mwbottom-y);
    case 2:  line(x,y,mwright-x,y);
    case 0:  line(x,y,xc,yc);
	     break;
  }
  while(r>=0)
  {
    circle(x,y,(int)r);
    r-=rstep;
    if(kbhit())
      keyhit();
  }
}
