/*
	clearwindow() - clears the prescribed screen area in 1 of n ways.
	If the 'way' parameter is illegal, a random 'way' is selected.
	Value returned to calling program is the value of 'way'.
*/

#include <graphics.h>
#include <conio.h>
#include <stdlib.h>

extern	writemode,	/* current state (1 or 0) of setwritemode() */
	clearflag,	/* clearwindow() resets this to 0 */
	maxcolor;	/* highest usable color # in calling program */
	keyhit(void);	/* takes action based on key pressed, then returns */


int clearwindow(int minx, int miny, int maxx, int maxy, int way, int color)
{
  int   a,b,c,d,        	/* right,down,left,up respectively */
	ways=16;		/* # of ways screen can be cleared */

  setwritemode(0);		/* xor lines over background */
  setcolor(color);		/* Black background when done */
  if((way>(ways-1))||(way<0))	/* invalid 'way' arg */
    way=random(ways);
  switch(way)
  {
    case  0:    a=0; b=0; c=0; d=1;     break;
    case  1:    a=0; b=0; c=1; d=0;     break;
    case  2:    a=0; b=0; c=1; d=1;     break;
    case  3:    a=0; b=1; c=0; d=0;     break;
    case  4:    a=0; b=1; c=0; d=1;     break;
    case  5:    a=0; b=1; c=1; d=0;     break;
    case  6:    a=0; b=1; c=1; d=1;     break;
    case  7:    a=1; b=0; c=0; d=0;     break;
    case  8:    a=1; b=0; c=0; d=1;     break;
    case  9:    a=1; b=0; c=1; d=0;     break;
    case 10:    a=1; b=0; c=1; d=1;     break;
    case 11:    a=1; b=1; c=0; d=0;     break;
    case 12:    a=1; b=1; c=0; d=1;     break;
    case 13:    a=1; b=1; c=1; d=0;     break;
    case 14:    a=1; b=1; c=1; d=1;     break;
    case 15:    clearviewport();	break;
  }
  if(way!=(ways-1))
    while((miny<=maxy)&&(minx<=maxx))
    {
      if(kbhit())
	keyhit();
      rectangle(minx,miny,maxx,maxy);
      minx+=a;
      miny+=b;
      maxx-=c;
      maxy-=d;
    }
  setcolor(1+random(maxcolor-1));	/* non-black drawing color */
  setwritemode(writemode);		/* reset to original value */
  clearflag=0;				/* reset flag in calling program */
  return(way);
}
