/*
	ellipses1() - draws nested ellipses
	ellipses2() - nested quarter-ellipses
	ellipses3() - nested, warped quarter-ellipses
	ellipses4() - nested, warped quarter-ellipses
	ellipses5() - nested, warped quarter-ellipses
	ellipses6() - nested, warped quarter-ellipses
	ellipses7() - "flowers" from nested ellipses
	ellipses8() - "flowers" with lines
*/

#include <graphics.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

extern	step,
	xc, yc,
	keyhit(void),
	quadrant(int,int,int,int);


int ellipses1(int x1,int y1,int x2,int y2)
{
  int	xcent=(x1+x2)>>1,
	ycent=(y1+y2)>>1,
	xradius=abs(x1-xcent),
	st,
	yradius=st=2+step%3;

  while(xradius>=step)
  {
    ellipse(xcent,ycent,0,360,xradius,yradius);
    xradius-=st;
    yradius+=st;
    if(kbhit())
      keyhit();
  }
}


int ellipses2(int x1,int y1,int x2,int y2)
{
  int	xcent=(x1+x2)>>1, xradius=max(x1,x2)-xcent,
	ycent=(y1+y2)>>1, yradius=max(y1,y2)-ycent,
	st=2+step%3,
	start, end;

  switch(quadrant(x1,y1,x2,y2))
  {
    case 1: start=270;	end=360;	break;
    case 2: start=180;	end=270;	break;
    case 3: start=90;	end=180;	break;
    case 4: start=0;	end=90;		break;
  }
  while((xradius>=step)&&(yradius>=step))
  {
    ellipse(xcent,ycent,start,end,xradius,yradius);
    xradius-=st;
    yradius-=st;
    if(kbhit())
      keyhit();
  }
}


int ellipses3(int x1,int y1,int x2,int y2)
{
  int	xcent=(x1+x2)>>1, xradius=max(x1,x2)-xcent,
	ycent=(y1+y2)>>1, yradius=max(y1,y2)-ycent,
	st=2+step%3,
	start, end;

  switch(quadrant(x1,y1,x2,y2))
  {
    case 1: start=270;	end=360;	break;
    case 2: start=180;	end=270;	break;
    case 3: start=90;	end=180;	break;
    case 4: start=0;	end=90;		break;
  }
  while((xradius>=1)&&(yradius>=1))
  {
    ellipse(xcent,ycent,start,end,xradius,yradius);
    xradius-=st;
    yradius+=st;
    if(kbhit())
      keyhit();
  }
}


int ellipses4(int x1,int y1,int x2,int y2)
{
  int	xcent=(x1+x2)>>1, xradius=max(x1,x2)-xcent,
	ycent=(y1+y2)>>1, yradius=max(y1,y2)-ycent,
	st=2+step%3,
	start, end;

  switch(quadrant(x1,y1,x2,y2))
  {
    case 1: start=270;	end=360;	break;
    case 2: start=180;	end=270;	break;
    case 3: start=90;	end=180;	break;
    case 4: start=0;	end=90;		break;
  }
  while((xradius>=1)&&(yradius>=1))
  {
    ellipse(xcent,ycent,start,end,xradius,yradius);
    xradius+=st;
    yradius-=st;
    if(kbhit())
      keyhit();
  }
}


int ellipses5(int x1,int y1,int x2,int y2)
{
  int	xcent=(x1+x2)>>1, xradius=max(x1,x2)-xcent,
	ycent=(y1+y2)>>1, yradius=max(y1,y2)-ycent,
	st=2+step%3,
	start, end;

  switch(quadrant(x1,y1,x2,y2))
  {
    case 1: start=225;  end=405;	break;
    case 2: start=135;	end=315;	break;
    case 3: start=45;	end=225;	break;
    case 4: start=-45;	end=135;	break;
  }
  while((xradius>=1)&&(yradius>=1))
  {
    ellipse(xcent,ycent,start,end,xradius,yradius);
    xradius+=st;
    yradius-=st;
    if(kbhit())
      keyhit();
  }
}


int ellipses6(int x1,int y1,int x2,int y2)
{
  int	xcent=(x1+x2)>>1, xradius=max(x1,x2)-xcent,
	ycent=(y1+y2)>>1, yradius=max(y1,y2)-ycent,
	minrad=max(xradius,yradius)>>1,
	start, end;

  if(step%2)
    switch(quadrant(x1,y1,x2,y2))
    {
      case 1:
      case 2: start=225;
	      end=315;
	      break;
      case 3:
      case 4: start=45;
	      end=135;
	      break;
    }
  else
    switch(quadrant(x1,y1,x2,y2))
    {
      case 1:
      case 4: start=135; end=225; break;
      case 2:
      case 3: start=315; end=405; break;
    }
  while((xradius>minrad)&&(yradius>minrad))
  {
    ellipse(xcent,ycent,start,end,xradius,yradius);
    xradius*=0.98;
    yradius/=0.98;
    if(kbhit())
      keyhit();
  }
}


int ellipses7(int x1,int y1,int x2,int y2)
{
  int	s,
	start=0,
	end=360;

  for(s=1;s<=step;s++)
  {
    ellipse(x1,y1,start,end,step,step);
    ellipse(x1,y2,start,end,step,step);
    ellipse(x2,y2,start,end,step,step);
    ellipse(x2,y1,start,end,step,step);

    ellipse(x1,y1,start,end,step,step+s);
    ellipse(x1,y2,start,end,step,step+s);
    ellipse(x2,y2,start,end,step,step+s);
    ellipse(x2,y1,start,end,step,step+s);

    ellipse(x1,y1,start,end,step+s,step);
    ellipse(x1,y2,start,end,step+s,step);
    ellipse(x2,y2,start,end,step+s,step);
    ellipse(x2,y1,start,end,step+s,step);

    if(kbhit())
      keyhit();
  }
}


int ellipses8(int x1,int y1,int x2,int y2)
{
  int	s,
	start=0,
	end=360;

  for(s=1;s<=step;s++)
  {
    ellipse(x1,y1,start,end,step,step);
    ellipse(x1,y2,start,end,step,step);
    ellipse(x2,y2,start,end,step,step);
    ellipse(x2,y1,start,end,step,step);

    ellipse(x1,y1,start,end,step,step+s);
    ellipse(x1,y2,start,end,step,step+s);
    ellipse(x2,y2,start,end,step,step+s);
    ellipse(x2,y1,start,end,step,step+s);

    ellipse(x1,y1,start,end,step+s,step);
    ellipse(x1,y2,start,end,step+s,step);
    ellipse(x2,y2,start,end,step+s,step);
    ellipse(x2,y1,start,end,step+s,step);

    rectangle(x1,y1,x2,y2);

    if(kbhit())
      keyhit();
  }
}
