/*
	GPRINTF: Used like PRINTF except the output is sent to the
	screen in graphics mode at the specified co-ordinate.

	Extracted from Borland's BGIDEMO.C by gjpateman 2/7/91

	Syntax:  gprintf(x, y, "Graphics device %-20s",driver);

	Prototype:  int gprintf(int xloc, int yloc, char *fmt, ... );
*/

#include <stdarg.h>
#include <stdio.h>
#include <graphics.h>

int gprintf(int x, int y, char *fmt, ... )
{
  va_list	argptr;			/* Argument list pointer        */
  char		str[140];		/* Buffer to build sting into   */
  int		cnt;			/* Result of SPRINTF for return */

  va_start(argptr, fmt);		/* Initialize va_ functions     */
  cnt = vsprintf(str, fmt, argptr );	/* prints string to buffer      */
  outtextxy(x, y, str );		/* Send string in graphics mode */
  va_end(argptr);			/* Close va_ functions          */
  return(cnt);				/* Return the conversion count  */
}
