/*
	tile() - grabs center of graphics screen & reproduces it many
	times over rest of screen, producing a "tiling" effect.  wmode
	may be XOR_PUT, COPY_PUT, OR_PUT, AND_PUT or NOT_PUT.
*/

#include <math.h>
#include <graphics.h>
#include <stdlib.h>

extern	restart;

int tile(int ulx, int uly, int lrx, int lry, int tilesperside, int wmode)
{
  unsigned char *image;		/* store screen image here  */
  int	width,height,		/* dimensions of area to copy to */
	tilewidth,tileheight,	/* dimensions of single tile */
	left,top,right,bottom,	/* image boundaries */
	x,y,			/* loop counters */
	hmarg,vmarg;		/* horizontal, vertical margins */


  /* find a width,height that is evenly divisible by tilesperside */
  tilewidth = (int)floor((lrx-ulx)/tilesperside);
  width = tilewidth * tilesperside;
  tileheight = (int)floor((lry-uly)/tilesperside);
  height = tileheight * tilesperside;

  /* use the differences between these values & the screen size as margins */
  hmarg=((lrx-ulx)-width)/2;
  vmarg=((lry-uly)-height)/2;

  /* grab the image at the screen center */
  left=hmarg+floor(tilesperside/2)*tilewidth;
  top=vmarg+floor(tilesperside/2)*tileheight;
  right=left+tilewidth;
  bottom=top+tileheight;
  image=(unsigned char *)malloc(imagesize(left,top,right,bottom));
  getimage(left,top,right,bottom,image);

  for(y=0;y<tilesperside;y++)
    for(x=0;x<tilesperside;x++)
      putimage(ulx-1+hmarg+x*tilewidth,uly-1+vmarg+y*tileheight,image,wmode);
  free(image);
  restart=1;
}